## piuparts 0.78

=== debian/changelog ===
piuparts (0.78) unstable; urgency=medium

  [ Andreas Beckmann ]
  * piuparts.py:
    - Refactor internal handling of reference chroot state.
    - Do not run custom scripts before/after installing fake essential
      packages.
    - Only warn on broken symlinks found between installing the dependencies
      of the package to be tested and installing the package itself.
    - Keep track of md5sums of the list of available packages in the chroot
      to recognize mirror pushes during distupgrade tests and outdated
      --end-meta meta-data.
    - Mount a new devpts instance on /dev/pts and /dev/ptmx inside the chroot
      for better pty separation from the host. Mount the current tty onto
      /dev/console in the chroot. Inspired by pbuilder.
    - Arguments to the --ignore/--ignore-regexp options (and internal
      ignored_files/ignored_patterns settings) that are prefixed with a ':'
      will verbosely log the ignored files if matched.
    - New option --upgrade-before-dist-upgrade for 2-stage upgrades:
      'apt-get upgrade && apt-get dist-upgrade'.
    - Do not ignore errors while removing packages.
    - Run panic handlers before aborting due to an unhandled exception.
  * piuparts.conf:
    - Use more aliases for mapping between releases and codenames to reduce
      the amount of changes needed on "moving targets" (like stable22sid)
      after a stable Debian release.
    - Set keyring for archived distros to debian-archive-removed-keys.gpg.
    - Add new suites: jessie2Xstretch, jessie2Xstretch-rcmd, doing two-stage
      upgrades (apt-get update && apt-get dist-upgrade) from jessie to stretch
      (without and with --install-recommends).
    - Enable stretch2proposed.  (Closes: #864933)
    - Use --warn-on-debsums-errors for tests ending in stretch.
    - Rotate aliases for testing=buster and stable=stretch.
    - Add new suites: buster, buster-rcmd, stretch2buster, stretch2buster-rcmd
    - Add new suites: stretch2bpo, stretch2bpo2buster for testing
      stretch-backports.
    - New (per-section) conffile setting: 'exclude-known-problems' can be set
      to a list of known problem iconffile names that should *not* be used for
      this section.
  * piuparts.conf.anbe: Add some more example sections.
  * distros.conf: Add support for buster-debug, buster-proposed-updates.
  * piupartslib/packagesdb.py:
    - Add new state "outdated" to ignore packages if a dependency distro
      already has a newer version.  (Closes: #856846)
    - Resolve packages in "outdated" state after dependency databases are
      initialized.
  * piuparts-slave.py:
    - Run piuparts on dummy package "TARBALL" (but skip tests) to create
      tarballs.
    - Add "chroot-meta-auto" config option to automatically maintain cached
      target chroot meta data (using --end-meta and --save-end-meta) for
      distupgrade tests instead of generating it on-the-fly.
    - Flush pending logfiles upon startup.
  * piuparts-analyze.py:
    - Process newest logfiles first, in case of timeouts.
    - Drop report_packages_with_many_logs(), obsoleted by archiving old logs.
    - Remove support for magic "$DISTRO/None" versions.
  * piuparts-report.py:
    - Plot all states in the graphs.
    - Support new states in plots (varying number of columns in counts.txt).
    - Reorder stacking in the bts_stats plot.
    - Defer rewriting unmodified maintainer and source summaries, refresh them
      once per month.
  * custom-scripts: Check for dummy package "TARBALL" to detect tarball
    creation phase.
  * scripts/is_testable_uninstallable:
    - Add exceptions to skip distupgrades of many buggy ancient packages.
      (Closes: #688250, #696081)
  * scripts/post_setup_dummy_users: Skip regular users when testing dpsyco*.
  * scripts/pre_distupgrade_exceptions:
    - Disable APT::Immediate-Configure on some squeeze->wheezy upgrade paths.
    - Add exceptions for old buggy packages.
  * scripts/post_{setup,distupgrade}_zz_backports: Avoid downgrading
    systemd/udev from jessie-backports to jessie during removal phase.
    (Closes: #856845)
  * scripts/post_distupgrade_exceptions: Add stretch->buster workarounds:
    - Remove empty unowned /etc/dbus-1/, /etc/dbus-1/system.d/.
    - Change permissions from 0755 to 0700 on /var/lib/polkit-1.
  * scripts-broken-symlinks/post_install_extras_unbreak_symlinks: New script
    for "fixing" some broken symlinks (e.g. by installing selected suggested
    packages) in tests using --fail-on-broken-symlinks.
  * scripts-debug-triggers/: New scripts for enabling dpkg trigger debugging.
  * conf/crontab-*: Set PATH and run scripts without absolute path.
  * master-bin/detect_archive_issues:
    - Look at failed logs older than 24 hours (48 hours previously).
    - Mark logfiles for immediate recycling upon first appearance.
    - Run twice per day, moving new logs to untestable within 24-36 hours.
  * master-bin/detect_network_issues:
    - Report the issues found in each logfile.
    - Detect alternate wording of gpg verification error.
    - Detect master and slave disagreement on the "current" version of a
      package due to using different mirrors and ongoing mirror push.
  * master-bin/detect_piuparts_issues:
    - Report the issues found in each logfile.
    - Recognize more problems caused by a full filesystem.
    - Recognize more failures when connecting to databases.
  * master-bin/detect_well_known_errors: Ignore known_problems conffiles
    listed in 'exclude-known-problems' in piuparts.conf.
  * Add known_problems/trigger_cycle_error.conf to report trigger cycles and
    other trigger problems.
  * Add bug templates for failing to upgrade from stretch to buster.
  * Update bug templates for long grown upgrades ending in buster.

  [ Holger Levsen ]
  * update TODO. Work on buster has begun. \o/
  * generate_daily_report.in: only add runtime to external script output if
    not already included.
  * master-bin/report_untestable_packages.in:


## piuparts 0.83~bpo9+1

=== debian/changelog ===
piuparts (0.83~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Holger Levsen <holger@debian.org>  Wed, 20 Dec 2017 10:42:08 +0000

piuparts (0.83) unstable; urgency=medium

  [ Andreas Beckmann ]
  * distros.conf:
    - Add experimental-debug.
  * piuparts.conf.anbe: Add some more example sections.
  * piupartslib/packagesdb.py:
    - Add new package data accessors name(), version(), test_versions().
    - Use test_versions() in all places referring to a piuparts test.
    - Set test_versions while loading versions from the final target distro.
    - Use the actual package versions for resolving the "outdated" state.
  * piuparts-analyze.py:
    - Merge report_newly_bugged_packages and process all sections.
  * piuparts-report.py, detect_well_known_errors.py, piuparts-analyze.py:
    - Use global locks to allow only one running instance of each script.
    - Acquire section locks to prevent concurrent processing of a section,
      including piuparts-master access.
    - Postpone busy sections and retry them later.
    - Run as three separate cronjobs.
  * conf/crontab-master:
    - Run detect_well_known_errors every three hours to avoid accumulating a
      large backlog of new logfiles.
    - Run piuparts-analyze twice per day.
    - Try piuparts-report every three hours s.t. we start 2-3 runs per day
      even with running times above 8-12 hours.
    - Run detect_{piuparts,network}_issues a short time before trying
      piuparts-report to exclude (most of) these logfiles from the report.
  * master-bin/report_newly_bugged_packages: Remove, merged into
    piuparts-analyze.
  * scripts/pre_distupgrade_zz_database-server: wheezy->jessie: Restart
    postgresql before upgrading the cluster, working around #882409.
  * Update policy references, the permalinks changed with the new toolchain.
  * Add bug template for failing to reinstall a package.
  * Adjust known_problems patterns for dpkg 1.19 message changes.

  [ Holger Levsen ]
  * dwke.py/-analyze.py/-report.py: quietly exit if another process is still
    running.
  * master-bin/detect_well_known_errors.py: compress output.
  * Bump standards version to 4.1.2, no changes needed.

 -- Holger Levsen <holger@debian.org>  Fri, 15 Dec 2017 11:12:13 +0000

piuparts (0.82) unstable; urgency=medium

  * Move xmlto from Build-Depends-Indep to Build-Depends.

 -- Holger Levsen <holger@debian.org>  Sat, 07 Oct 2017 17:30:19 +0200

piuparts (0.81) unstable; urgency=medium

  [ Andreas Beckmann ]
  * piuparts.py:
    - Add to ignored_files:
      + /var/log/tallylog  (Closes: #877592)
    - Run post_chroot_unpack scripts before initial apt-get update.
  * piuparts-analyze.py:
    - Add PiupartsBTS, a caching wrapper around debianbts.
  * General python code and style cleanup.
    Consistently use 'with open(...) as ...:' for scoped open files.
  * scripts/{pre,post}_test_exceptions: Add exception to prevent testing
    corekeeper from changing the core file settings in the running kernel.
  * scripts/pre_distupgrade_zz_database-server: sid/buster has postgresql 10.
  * Separate scripts-lenny/ from scripts-squeeze/.
  * scripts-squeeze/post_{setup,distupgrade}_squeeze-fake-essential:
    - Treat install-info as fake-essential for all tests ending in squeeze.
  * scripts-broken-symlinks/post_install_extras_unbreak_symlinks: Unbreak more
    symlinks.  (Closes: #857151)
  * master-bin/detect_piuparts_issues: Detect another way of 'apt-cache show'
    failing.  (Closes: #877417)
  * master-bin/distill_alternatives_log: Parse piuparts.conf to find the
    sections that use scripts-log-alternatives.
  * master-bin/generate_daily_report: Most parts are now separate cronjobs.
  * Add bug template for stable -> sid file overwrite errors.
  * Use copyright notices without FSF street address.

  [ Simon McVittie ]
  * Consider the /usr merge to be acceptable variation. Files that the
    dpkg database considers to be in /bin, /sbin, /lib/**, /lib*/**
    are now allowed to be physically in /usr/bin, etc. due to symlinks in
    the root directory, as created by usrmerge or debootstrap --merged-usr.
    (Closes: #860433)

  [ Holger Levsen ]
  * Fix syntax errors in git snapshot running on piuparts.debian.org, thanks
    to Boud Roukema and Philipp Huebner for the reports.
    (Closes: #875605, #875664)
  * Drop code to support using autopkgtest as a test backend. This code was
    merged in 2008 from Ubuntu, but it's unclear (and unlikely) that it still
    works. Also it never has really been supported. (See #815084)
  * Bump standards version to 4.1.1, no changes needed.
  * Update TODO.

  [ Michael Stapelberg ]
  * piuparts-distill: correctly handle errors.

 -- Holger Levsen <holger@debian.org>  Thu, 05 Oct 2017 15:56:25 +0200

piuparts (0.80) unstable; urgency=medium

  [ Michael Stapelberg ]
  * debiman-piuparts-distill:
    - increase maximum token size.
    - bugfix: wait until all results are collected.
    - don’t print all results.
  * distill_alternatives_log: also process buster.

  [ Holger Levsen ]
  * Move asciidoc to from Build-Depends-Indep to Build-Depends. (Newly needed
    because d697f2991 changed piuparts-master to an arch:any package.) Thanks
    to Adrian Bunk. (Closes: #873825)

 -- Holger Levsen <holger@debian.org>  Thu, 31 Aug 2017 17:38:11 +0200

piuparts (0.79) unstable; urgency=medium

  [ Holger Levsen ]
  * slave-run: properly delete all screenlogs from previous runs.
  * Bump standards version to 4.1.0, change priority from extra to optional.
  * Depend on debhelper >= 10.2.5~ and bump debian/compat to 10.

  [ Andreas Beckmann ]
  * piuparts.py:
    - Do not ignore errors while purging packages.
    - Add post_test_* custom scripts. These are run exactly once at the end
      of each test (before comparing with the reference chroot state).
    - is_testable_* custom scripts can use return value '2' to make a test
      fail without actually installing the package. Use for (unfixable)


=== debian/control ===
Source: piuparts
Maintainer: piuparts developers team <piuparts-devel@lists.alioth.debian.org>
Uploaders:
 Holger Levsen <holger@debian.org>
Section: devel
Priority: optional
Standards-Version: 4.1.2
Build-Depends:
 asciidoc,
 debhelper (>= 10.2.5~),
 dh-python,
 python (>= 2.7),
 python-debian,
 python-apt,
 python-distro-info,
 python-nose,
 python-debianbts,
 python-yaml,
 python-mox3,
 python-lzma,
 golang-any,
 xmlto,
Build-Depends-Indep:
 git,
Homepage: https://piuparts.debian.org
Vcs-Git: https://anonscm.debian.org/git/piuparts/piuparts.git
Vcs-Browser: https://anonscm.debian.org/git/piuparts/piuparts.git
X-Python-Version: >= 2.7

Package: piuparts
Architecture: all
Pre-Depends:
 dpkg (>= 1.15.7.2~),
Depends:
 piuparts-common (= ${binary:Version}),
 debootstrap (>= 1.0.89~),
 debsums (>= 2.2.2~),
 lsb-release,
 lsof,
 mount,
 python-debian,
 ${python:Depends},
 ${misc:Depends},
Recommends:
 adequate
Suggests:
 schroot
Description: .deb package installation, upgrading, and removal testing tool
 piuparts tests that .deb packages (as used by Debian) handle
 installation, upgrading, and removal correctly. It does this by
 creating a minimal Debian installation in a chroot, and installing,
 upgrading, and removing packages in that environment, and comparing the
 state of the directory tree before and after. piuparts reports any
 files that have been added, removed, or modified during this process.
 .
 piuparts is meant as a quality assurance tool for people who create .deb
 packages to test them before they upload them to the Debian package archive.

Package: piuparts-master
Architecture: any
Depends:
 piuparts-common (>= ${source:Version}),
 piuparts-common (<< ${source:Version}+),
 adduser,
 openssh-server,
 python-debianbts,
 tango-icon-theme,
 xz-utils,
 python-yaml,
 python (>= 2.7),
 ${python:Depends},
 ${shlibs:Depends},
 ${misc:Depends},
Recommends:
 apache2 | httpd,
 ghostscript,
 python-rpy2,
 r-base-dev,
 r-recommended,
 devscripts,
 libsoap-lite-perl,
Breaks:
 piuparts (<= 0.44)
Replaces:
 piuparts (<= 0.44)
Description: piuparts master components
 piuparts is meant as a quality assurance tool for people who create .deb
 packages to test them before they upload them to the Debian package archive.
 A master/slave piuparts installation is used for testing complete archives
 as it is done on https://piuparts.debian.org/.
 .
 This package provides the piuparts-master, which needs one or more slaves to
 operate. It also contains piuparts-report to generate web pages with the
 testing results as well as documentation.

Package: piuparts-slave
Architecture: all
Depends:
 piuparts (= ${binary:Version}),
 piuparts-common (= ${binary:Version}),
 adduser,
 openssh-client,
 screen,
 sudo,
 python (>= 2.7),
 ${python:Depends},
 ${misc:Depends},
Suggests:
 schroot
Breaks:
 piuparts (<= 0.44)
Replaces:
 piuparts (<= 0.44)
Description: piuparts slave components
 piuparts is meant as a quality assurance tool for people who create .deb
 packages to test them before they upload them to the Debian package archive.
 A master/slave piuparts installation is used for testing complete archives
 as it is done on https://piuparts.debian.org/.
 .
 This package provides the piuparts slave components, which need a piuparts
 master to operate. See the documentation in the piuparts-master package.

Package: piuparts-common
Architecture: all
Depends:
 python-apt,
 python-distro-info,
 python-lzma,
 ${python:Depends},
 ${misc:Depends},
Breaks:
 piuparts (<= 0.44)
Replaces:
 piuparts (<= 0.44)
Description: common piuparts components
 piupartslib, common library used by piuparts-master, -report, -analyze and
 -slave.
 .
 See https://piuparts.debian.org or the piuparts package to learn more about
 piuparts.

## piuparts 0.84

=== Makefile ===
prefix = /usr/local
sbindir = $(prefix)/sbin
sharedir = $(prefix)/share
mandir = $(sharedir)/man
man1dir = $(mandir)/man1
man8dir = $(mandir)/man8
libdir = $(prefix)/lib
docdir = $(prefix)/share/doc/piuparts/
site27 = $(libdir)/python2.7/dist-packages
htdocsdir	 = $(sharedir)/piuparts/htdocs
etcdir = $(prefix)/etc

distribution=${shell dpkg-parsechangelog | sed -n 's/^Distribution: *//p'}
ifeq ($(distribution),UNRELEASED)
version		:= ${shell echo "`dpkg-parsechangelog | sed -n 's/^Version: *//p'`~`date +%Y%m%d%H%M`~`git describe --dirty`"}
else
version		:= ${shell dpkg-parsechangelog | sed -n 's/^Version: *//p'}
endif


# generate several scripts, conffiles, ... from templates (*.in, *.py)
# by substituting placeholders
SCRIPTS_TEMPLATES	 = $(wildcard *.in master-bin/*.in slave-bin/*.in conf/*.in)
SCRIPTS_PYTHON_BINARY	 = $(wildcard *.py master-bin/*.py slave-bin/*.py)
SCRIPTS_GENERATED	 = $(SCRIPTS_TEMPLATES:.in=) $(SCRIPTS_PYTHON_BINARY:.py=)
DOCS_GENERATED		 = piuparts.1 piuparts.1.html piuparts_slave_run.8 piuparts_slave_join.8 piuparts_slave_stop.8 README.html README_server.html

define placeholder_substitution
	sed -r \
	-e 's/__PIUPARTS_VERSION__/$(version)/g' \
	-e 's%@sharedir@%$(sharedir)%g' \
	-e 's%@libdir@%$(libdir)%g' \
	$< > $@
endef

%: %.in Makefile
	$(placeholder_substitution)

%: %.py Makefile
	$(placeholder_substitution)


all: build

python_scripts	 = $(wildcard *.py piupartslib/*.py master-bin/*.py slave-bin/*.py)
python-syntax-check:
	@set -e -x; $(foreach py,$(python_scripts),python -m py_compile $(py);)
	$(RM) $(python_scripts:=c)

build: build-stamp build-master-stamp
build-slave: build-stamp
build-master: build-stamp build-master-stamp

build-stamp: $(SCRIPTS_GENERATED) $(DOCS_GENERATED) Makefile
	$(MAKE) -C instances
	$(MAKE) python-syntax-check
	touch $@

build-master-stamp:
	(cd helpers/debiman-piuparts-distill && go build)
	touch $@

build-doc: $(DOCS_GENERATED)

README.html: README.txt
	a2x --copy -a toc -a toclevels=3 -f xhtml -r /etc/asciidoc/ README.txt

README_server.html: README_server.txt
	a2x --copy -a toc -a toclevels=3 -f xhtml -r /etc/asciidoc/ README_server.txt

piuparts.1: piuparts.1.txt
	a2x -f manpage piuparts.1.txt

piuparts_slave_run.8: piuparts_slave_run.8.txt
	a2x -f manpage piuparts_slave_run.8.txt

piuparts_slave_join.8: piuparts_slave_join.8.txt
	a2x -f manpage piuparts_slave_join.8.txt

piuparts_slave_stop.8: piuparts_slave_stop.8.txt
	a2x -f manpage piuparts_slave_stop.8.txt

piuparts.1.html: piuparts.1.txt
	a2x --copy -f xhtml piuparts.1.txt


install-doc: build-stamp
	install -d $(DESTDIR)$(docdir)/
	install -m 0644 README.txt README.html README_server.txt README_server.html docbook-xsl.css $(DESTDIR)$(docdir)/
	install -d $(DESTDIR)$(man1dir)
	install -m 0644 piuparts.1 $(DESTDIR)$(man1dir)/
	install -d $(DESTDIR)$(man8dir)
	install -m 0644 piuparts_slave_run.8 piuparts_slave_join.8 piuparts_slave_stop.8 $(DESTDIR)$(man8dir)/
	gzip -9f $(DESTDIR)$(man1dir)/piuparts.1
	gzip -9f $(DESTDIR)$(man8dir)/piuparts_slave_run.8
	gzip -9f $(DESTDIR)$(man8dir)/piuparts_slave_join.8
	gzip -9f $(DESTDIR)$(man8dir)/piuparts_slave_stop.8
	install -m 0644 piuparts.1.html $(DESTDIR)$(docdir)/

install-conf: build-stamp
	install -d $(DESTDIR)$(etcdir)/piuparts
	install -m 0644 conf/piuparts.conf.sample $(DESTDIR)$(etcdir)/piuparts/piuparts.conf
	install -m 0644 conf/distros.conf $(DESTDIR)$(etcdir)/piuparts/
	install -d $(DESTDIR)$(etcdir)/apache2/conf-available
	install -m 0644 conf/piuparts-master.conf $(DESTDIR)$(etcdir)/apache2/conf-available/

install-conf-4-running-from-git: build-stamp
	install -d $(DESTDIR)$(etcdir)/piuparts
	install -m 0644 conf/crontab-master $(DESTDIR)$(etcdir)/piuparts/
	install -m 0644 conf/crontab-slave $(DESTDIR)$(etcdir)/piuparts/
	install -m 0644 conf/distros.conf $(DESTDIR)$(etcdir)/piuparts/
	install -m 0644 instances/piuparts.conf.* $(DESTDIR)$(etcdir)/piuparts/
	install -d $(DESTDIR)$(sharedir)/piuparts/slave
	install -m 0755 update-piuparts-slave-setup $(DESTDIR)$(sharedir)/piuparts/slave/
	install -d $(DESTDIR)$(sharedir)/piuparts/master
	install -m 0755 update-piuparts-master-setup $(DESTDIR)$(sharedir)/piuparts/master/

install-common: build-stamp
	install -d $(DESTDIR)$(site27)/piupartslib
	install -m 0644 piupartslib/*.py $(DESTDIR)$(site27)/piupartslib/

	install -d $(DESTDIR)$(sharedir)/piuparts/lib
	install -m 0644 lib/*.sh $(DESTDIR)$(sharedir)/piuparts/lib/

install-master: build-master-stamp install-common
	install -d $(DESTDIR)$(libdir)/piuparts/
	install -m 0755 helpers/debiman-piuparts-distill/debiman-piuparts-distill $(DESTDIR)$(libdir)/piuparts/

	install -d $(DESTDIR)$(sharedir)/piuparts
	install -m 0755 piuparts-master piuparts-master-backend piuparts-report piuparts-analyze $(DESTDIR)$(sharedir)/piuparts/

	# do not install the templates (*.in, *.py)
	install -d $(DESTDIR)$(sharedir)/piuparts/master
	install -m 0755 $(filter-out %.in %.py,$(wildcard master-bin/*)) $(DESTDIR)$(sharedir)/piuparts/master/

	install -d $(DESTDIR)$(sharedir)/piuparts/known_problems
	install -m 0644 known_problems/*.conf $(DESTDIR)$(sharedir)/piuparts/known_problems/

	install -d $(DESTDIR)$(htdocsdir)
	install -m 0644 htdocs/*.* $(DESTDIR)$(htdocsdir)/

	install -d $(DESTDIR)$(htdocsdir)/images
	install -m 0644 htdocs/images/*.* $(DESTDIR)$(htdocsdir)/images/

	install -d $(DESTDIR)$(htdocsdir)/templates/mail
	install -m 0644 bug-templates/*.mail $(DESTDIR)$(htdocsdir)/templates/mail/

	#install -d $(DESTDIR)$(etcdir)/piuparts/known_problems
	#install -m 0644 known_problems/*.conf $(DESTDIR)$(etcdir)/piuparts/known_problems/

install-slave: install-common
	install -d $(DESTDIR)$(sbindir)
	install -m 0755 piuparts $(DESTDIR)$(sbindir)/

	install -d $(DESTDIR)$(sharedir)/piuparts
	install -m 0755 piuparts-slave $(DESTDIR)$(sharedir)/piuparts/

	# do not install the templates (*.in, *.py)
	install -d $(DESTDIR)$(sharedir)/piuparts/slave
	install -m 0755 $(filter-out %.in %.py,$(wildcard slave-bin/*)) $(DESTDIR)$(sharedir)/piuparts/slave/

	install -d $(DESTDIR)$(etcdir)/piuparts
	@set -e -x ; \
	for d in $$(ls custom-scripts) ; do \
		install -d $(DESTDIR)$(etcdir)/piuparts/$$d ; \
		install -m 0755 custom-scripts/$$d/* $(DESTDIR)$(etcdir)/piuparts/$$d/ ; done

install: install-master install-slave


check:
	nosetests --verbose

clean:
	rm -f build-stamp
	rm -f build-master-stamp
	rm -f $(DOCS_GENERATED)
	rm -f piuparts.1.xml README.xml README_server.xml docbook-xsl.css piuparts.html
	rm -f *.pyc piupartslib/*.pyc master-bin/*.pyc slave-bin/*.pyc tests/*.pyc
	rm -f $(SCRIPTS_GENERATED)
	$(RM) helpers/debiman-piuparts-distill/debiman-piuparts-distill
	$(MAKE) -C instances clean


# for maintainer convenience only
check-whitespace:
	grep -r --exclude-dir .git --exclude '*.pyc' --exclude '*.png' --exclude '*.ico' -E '\s+$$' . || echo "no trailing whitespace found"
	grep -r --exclude-dir .git --exclude '*.pyc' --exclude '*.png' --exclude '*.ico' -P ' \t' . || echo "no space-tab combo found"

# for maintainer convenience only
tg-deps:
	tg summary --graphviz | dot -T png -o deps.png
	xli deps.png &

=== debian/changelog ===
piuparts (0.84) unstable; urgency=medium

  * debian/control:
    - Add "Rules-Requires-Root: no" to support building as non-root.
      (I've also confirmed that the build output is bit by bit identical with
      and without this.)
    - Bump standards version to 4.1.3, no changes needed.
  * piuparts-report.py: credit Andreas properly.
  * Bump debian/compat to 11 and build-depend on debhelper >= 11~.

 -- Holger Levsen <holger@debian.org>  Fri, 16 Feb 2018 12:34:20 +0000

=== debian/control ===
--- 
+++ 
@@ -4,10 +4,11 @@
  Holger Levsen <holger@debian.org>
 Section: devel
 Priority: optional
-Standards-Version: 4.1.2
+Standards-Version: 4.1.3
+Rules-Requires-Root: no
 Build-Depends:
  asciidoc,
- debhelper (>= 10.2.5~),
+ debhelper (>= 11~),
  dh-python,
  python (>= 2.7),
  python-debian,

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ --with python2


override_dh_auto_build:
	$(MAKE) prefix=/usr build build-doc

override_dh_auto_install:
	$(MAKE) DESTDIR=$(CURDIR)/debian/tmp prefix=/usr etcdir=/etc install install-doc install-conf

override_dh_python2:
	dh_python2 -p piuparts-master -p piuparts-slave /usr/share/piuparts
	dh_python2 -N piuparts-master -N piuparts-slave

## piuparts 0.90

=== debian/changelog ===
piuparts (0.90) unstable; urgency=medium

  [ Michael Stapelberg ]
  * debiman-piuparts-distill: also consider --install, fixes
    https://github.com/Debian/debiman/issues/106

  [ Holger Levsen ]
  * Bump standards version to 4.2.0, no changes needed.

 -- Holger Levsen <holger@debian.org>  Mon, 13 Aug 2018 13:37:03 +0200

piuparts (0.89) unstable; urgency=medium

  * scripts/pre_install_exceptions: force cleanup of sympa's spool
    directories. (Closes: #673972)
  * d/control:
    - move Built-Using: to piuparts-master binary package.
    - add Xs-Go-Import-Path: header.

 -- Holger Levsen <holger@debian.org>  Tue, 12 Jun 2018 14:44:37 +0000

piuparts (0.88) unstable; urgency=medium

  * Recycle failed packages in sid after 2 days and force rescheduling them
    2 days later.
  * d/control:
    - shorten Vcs: headers.
    - drop versioned Pre-Depends on dpkg which is even satisfied in
      oldoldstable.
    - drop Breaks and Replaces on versions of piuparts which are older than
      oldoldstable.
    - add "Built-Using: ${misc:Built-Using}" which is needed because we ship
      golang binaries, thanks lintian.

 -- Holger Levsen <holger@debian.org>  Fri, 08 Jun 2018 13:17:44 +0000

piuparts (0.87) unstable; urgency=medium

  [ Philipp Hahn ]
  * piuparts.py: use `apt-cache show --no-all-versions` to prevent generating
    a "piuparts-depends-dummy" package with multiple dependencies on the same
    package with different versions. (Closes: #898606)

  [ Holger Levsen ]
  * Update all occurrences of piuparts-devel@lists.alioth.debian.org with
    piuparts-devel@alioth-lists.debian.net.
  * Drop X-Python-Version header from debian/control.

 -- Holger Levsen <holger@debian.org>  Sat, 02 Jun 2018 11:36:36 +0000

piuparts (0.86) unstable; urgency=medium

  * debian/control: switch packaging to salsa.debian.org. Thanks to the alioth
    admins for providing such a nice service so long!
  * Update several occurrences of anonscm.debian.org and git.debian.org with
    salsa.debian.org URLs.
  * index.tpl: add news entry about the salsa migration.
  * debian/copyright: update years of my contributions.

 -- Holger Levsen <holger@debian.org>  Sat, 28 Apr 2018 14:57:34 -0300

piuparts (0.85) unstable; urgency=medium

  [ Agustin Henze ]
  * piuparts.py:
    - Add docker support, new param is introduced `--docker-image`.
      (Closes: #893731)
    - Deprecate --keep-tmpdir in favor of --keep-env (Closes: #894232)
    - Create ${ENV}/dev/ptmx path if it doesn't exist (Closes: #895380)
    - Create ${ENV}/dev/null if it doesn't exist ASAP (Closes: #895379)
  * Add `docker.io` as suggested package.
  * Reworded documentation for `--keep-env` and `--schroot` parameters.

  [ Holger Levsen ]
  * dwke.py: change logging to make relevant information more visible.
  * detect_*_issues.in: improve output.
  * report_untestable_packages.in: improve output.
  * piuparts.1.txt: improve wording for docker related changes and add
    explaination about the limitations of docker support.
  * Bump standards version to 4.1.4, no changes needed.

 -- Holger Levsen <holger@debian.org>  Sat, 14 Apr 2018 17:39:13 -0300

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,10 @@
 Source: piuparts
-Maintainer: piuparts developers team <piuparts-devel@lists.alioth.debian.org>
+Maintainer: piuparts developers team <piuparts-devel@alioth-lists.debian.net>
 Uploaders:
  Holger Levsen <holger@debian.org>
 Section: devel
 Priority: optional
-Standards-Version: 4.1.3
+Standards-Version: 4.2.0
 Rules-Requires-Root: no
 Build-Depends:
  asciidoc,
@@ -24,14 +24,12 @@
 Build-Depends-Indep:
  git,
 Homepage: https://piuparts.debian.org
-Vcs-Git: https://anonscm.debian.org/git/piuparts/piuparts.git
-Vcs-Browser: https://anonscm.debian.org/git/piuparts/piuparts.git
-X-Python-Version: >= 2.7
+Vcs-Git: https://salsa.debian.org/debian/piuparts
+Vcs-Browser: https://salsa.debian.org/debian/piuparts
+Xs-Go-Import-Path: salsa.debian.org/debian/piuparts
 
 Package: piuparts
 Architecture: all
-Pre-Depends:
- dpkg (>= 1.15.7.2~),
 Depends:
  piuparts-common (= ${binary:Version}),
  debootstrap (>= 1.0.89~),
@@ -45,7 +43,8 @@
 Recommends:
  adequate
 Suggests:
- schroot
+ schroot,
+ docker.io,
 Description: .deb package installation, upgrading, and removal testing tool
  piuparts tests that .deb packages (as used by Debian) handle
  installation, upgrading, and removal correctly. It does this by
@@ -59,6 +58,7 @@
 
 Package: piuparts-master
 Architecture: any
+Built-Using: ${misc:Built-Using}
 Depends:
  piuparts-common (>= ${source:Version}),
  piuparts-common (<< ${source:Version}+),
@@ -80,10 +80,6 @@
  r-recommended,
  devscripts,
  libsoap-lite-perl,
-Breaks:
- piuparts (<= 0.44)
-Replaces:
- piuparts (<= 0.44)
 Description: piuparts master components
  piuparts is meant as a quality assurance tool for people who create .deb
  packages to test them before they upload them to the Debian package archive.
@@ -108,10 +104,6 @@
  ${misc:Depends},
 Suggests:
  schroot
-Breaks:
- piuparts (<= 0.44)
-Replaces:
- piuparts (<= 0.44)
 Description: piuparts slave components
  piuparts is meant as a quality assurance tool for people who create .deb
  packages to test them before they upload them to the Debian package archive.
@@ -129,10 +121,6 @@
  python-lzma,
  ${python:Depends},
  ${misc:Depends},
-Breaks:
- piuparts (<= 0.44)
-Replaces:
- piuparts (<= 0.44)
 Description: common piuparts components
  piupartslib, common library used by piuparts-master, -report, -analyze and
  -slave.

## piuparts 0.98

=== debian/changelog ===
piuparts (0.98) unstable; urgency=medium

  [ Holger Levsen ]
  * piuparts-reports.py: add link to states graph for each suite.
  * instances/piuparts.conf-template.pejacevic: increase sid-nodoc's
    precedence.
  * Refactor reschedule_piuparts_tests to use new global configuration
    variable 'testing-suite'.
  * generate_daily_report: show failures in sid, $TESTING and testing2sid
    at the top of the report.
  * master-bin/prepare_backup: ignore empty submissions.txt for $TESTING-pu
    and $TESTING-security.
  * Update TODO for bullseye.

  [ Andreas Beckmann ]
  * piuparts.py:
    - If packages were downgraded to restore the reference chroot state
      reinstall the downgraded-to version again to recover potentially lost
      files in case of bad interactions of Breaks/Replaces with downgrading.
  * distros.conf: Add support for buster partial distros.
  * piuparts.conf:
    - Use --warn-on-others for [sid-strict] only.
    - Add sections [buster-security], [buster-pu] and [buster2proposed].
    - Add sections [stretch2Xbuster] and [stretch2Xbuster-rcmd].
    - Add section [sid-broken-symlinks], failing on broken symlinks
  * piuparts-slave.py:
    - Catch IOError while creating tarballs, will be retried later.
  * scripts/is_testable_uninstallable:
    - Refactor handling of known uninstallable packages.
  * scripts-multi-distro-upgrade/: New custom scripts for distupgrade tests
    spanning a series of distros.
  * Add metapackages piuparts-{master,slave}-from-git-deps to ease running
    piuparts-master and piuparts-slave instances from git.

 -- Holger Levsen <holger@debian.org>  Fri, 01 Mar 2019 11:27:47 +0100

piuparts (0.97) unstable; urgency=medium

  [ Andreas Beckmann ]
  * Ignore broken /var/lib/mender symlink.  (Closes: #915680)
  * scripts/pre_distupgrade_zz_database-server: Also act on dist-upgrades
    within a release, e.g. stable -> stable-proposed-updates.
  * piuparts-slave.py:
    - Support prepending a setarch command to the piuparts invocation.
  * piuparts-report.py:
    - Report [cruft] in logfile lists.

  [ David Steele ]
  * instances/piuparts.conf-template.pejacevic:
    - report results of stable2sid to DDPO.
    - swap stable2sid and stable22sid priorities, to promote the one reported
      to DDPO.

  [ Holger Levsen ]
  * slave_bin: on stop, show what's keeping the slaves busy, to identify
    packages with a very long installation time.
  * Makefile: include @sbindir@ in placeholder_substitution.
  * instances/piuparts.conf-template.pejacevic: lower priorities of oldstable
    suites.

  [ Herbert Fortes ]
  * piuparts.py, piuparts-slave.py, piupartslib/pkgsummary.py and
    piuparts-analyze.py: add '()' to print. Py2 and Py3 compatible.
  * piupartslib/dwke.py:
       - class Problem:
           - Class attr instead of instance attr
             Save some memory
       - get_file_dict function:
           - dictionary comprehension. "More readable and
             often faster at the same time".
       - create_problem_list function:
            - list.sort() instead of sorted(list).
              sorted() returns a *new* sorted list. This is
              not necessary here.
              list.sort() sorts the list in place.
              Save some memory
       - make_kprs function: do not concat str, simplify 'if' statement.

 -- Holger Levsen <holger@debian.org>  Mon, 11 Feb 2019 12:30:10 +0100

piuparts (0.96) unstable; urgency=medium

  [ Andreas Beckmann ]
  * bug-templates: Raise severity of "fails to purge" errors to serious.
   (see #918379)
  * distros.conf: Add jessie-lts as a full distro.
  * piuparts.conf:
    - Use jessie-lts as upgrade target and rename section
      [jessie2proposed] => [jessie2lts]
    - Add sections [wheezy2jessie-lts] and [jessie-lts2stretch].
    - [wheezy2bpo2jessie]: Use jessie-lts as final upgrade target.
    - Disable sections [wheezy-pu], [jessie-pu]: not used for lts releases.
  * scripts/post_distupgrade_exceptions:
    - Handle /etc/ca-certificates.conf stretch -> buster upgrade by
      normalizing the file to match fresh installations.  (Closes: #889852)
  * scripts-broken-symlinks: Unbreak more symlinks.

  [ Holger Levsen ]
  * htdocs/index.tpl: stop referring people to the #debian-qa IRC channel, we
    really prefer mail nowadays.
  * instances/piuparts.conf-template.pejacevic:
    - include sid-strict into json outputs.
    - improve sid-strict description. Closes: #918379
  * master-bin/detect_piuparts_issues: ignore files which vanish during run.
  * Bump standards version to 4.3.0, no changes needed.
  * d/copyright: update years.

 -- Holger Levsen <holger@debian.org>  Sun, 13 Jan 2019 16:56:06 +0100

piuparts (0.95) unstable; urgency=medium

  [ Holger Levsen ]
  * piuparts.py: add /var/lib/debian-security-support/ to self.ignored_files.
    (Closes: #749317)
  * Reduce number of mails per day, from 34 down to 1. (Closes: #912591)
    - lib/write_log.sh: new helper to publish logs in htdocs/logs.
    - master-bin/master_shell_runner: new script to run python scripts to
      redirect logs to htdocs/logs.
    - master-bin/generate_daily_report:
      - redirect logs of called scripts to htdocs/logs.
      - include listing of htdocs/logs/$TODAY into daily report.
      - publish dailyreport.txt in htdocs/logs/$TODAY instead of htdocs/.
    - master-bin/detect_archive_issues, detect_piuparts_issues,
      detect_network_issues, reschedule_oldest_logs, rotate_master_logs,
      report_untestable_packages and report_stale_reserved_packages: redirect
      logs to htdocs/logs.
    - conf/crontab-master.in: run detect_well_known_errors, piuparts-report
      and piuparts-analyze through the new master_shell_runner script.
    - master-bin/rotate_master_logs: compress htdocs/logs older than a week.
    - piuparts-report.py: add navigation link to https://piuparts.d.o/logs/
    - htdocs/news.tpl: explain the result of these changes.
  * d/control: use canonical URL for Vcs-Git, thanks lintian.


## piuparts 1.0.0~bpo9+1

=== Makefile ===
--- 
+++ 
@@ -28,8 +28,9 @@
 define placeholder_substitution
 	sed -r \
 	-e 's/__PIUPARTS_VERSION__/$(version)/g' \
+	-e 's%@libdir@%$(libdir)%g' \
 	-e 's%@sharedir@%$(sharedir)%g' \
-	-e 's%@libdir@%$(libdir)%g' \
+	-e 's%@sbindir@%$(sbindir)%g' \
 	$< > $@
 endef

=== debian/changelog ===
piuparts (1.0.0~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Holger Levsen <holger@debian.org>  Mon, 08 Jul 2019 15:59:18 +0200

piuparts (1.0.0) unstable; urgency=medium

  [ David Steele ]
  * piuparts-reports.py:
    Revert "Don't add results from outdated binaries to summary.json" from
    0.94. The reverted commit is 62a6b3c438f42480ce3a08996ed4994de1561591.
    The patch was added to avoid incorporating summary.json reporting results
    for binary packages which are no longer part of the source package. It
    stopped Piuparts from blocking the source package from testing migration.
    It has a bug related to "upgrade test" sections, which cause a large
    number of packages to incorrectly be reported in the "waiting" state.

  [ Andreas Beckmann ]
  * piuparts.py:
    - Add '--merged-usr' support when using debootstrap to create the chroot.
    - Add '--distupgrade-to-testdebs-from DIR' as a shorthand for
      '--bindmount DIR --testdebs-repo DIR --distupgrade-to-testdebs'.
  * distros.conf:
    - wheezy* has been archived/removed.
    - jessie* has been partially archived/removed.
    - Add buster-backports.
    - Add bullseye-proposed-updates.
  * piuparts.conf:
    - Add section [sid-merged-usr], using --merged-usr.  (Closes: #848968)
    - Use --warn-on-debsums-errors for tests ending in buster.
    - Rename [stretch2proposed] to [stretch2next]
      and [buster2proposed] to [buster2next].
  * piupartslib/packagesdb.py:
    - Keep recycled pass logs while waiting for new test results, continuing
      to show them as "successfully-tested" instead of "waiting-to-be-tested".
    - Add (hardcoded) list of missing dependencies that resolve to
      "ignore-does-not-exist".
      Used for packages to be skipped via "is_installable_*" scripts to
      exclude them from "dependency-does-not-exist" state.
  * piuparts-slave.py:
    - New option "slave-flush-interval" to flush logs more frequently to the
      master. Set to 30 minutes.
    - New option "chroot-meta-directory" to share reference target chroot
      metadata between slave instances.
  * piuparts-report.py:
    - Omit states with 0 packages from section summaries.
  * scripts/{post_chroot_unpack,pre_distupgrade}_allow_unauthenticated:
    - Disable Check-Valid-Until for wheezy/updates and jessie-backports.
  * scripts/post_distupgrade_exceptions:
    - Handle /var/lib/pam/seen stretch -> buster upgrade by running
      pam-auth-update if needed. Workaround for #920760.
  * scripts/pre_remove_40_find_unowned_lib_links:
    - Handle --merged-usr environments.
  * master-bin/reschedule_piuparts_tests: Do not act on 'bugged/*.log' and
    'affected/*.log' by default. Add --bugged, --affected flags.

  [ Holger Levsen ]
  * Declare this release to be version 1.0.0, finally. May the force be with
    you.
  * htdocs/news.tpl:
    - add news about sid-merged-usr being tested.
    - add news about the 1.0.0 release.
  * piuparts_slave_join.8.txt: update revdate to date of last change.

 -- Holger Levsen <holger@debian.org>  Sat, 04 May 2019 21:37:32 +0200

## piuparts 1.0.0+deb10u1

=== Makefile ===
--- 
+++ 
@@ -90,12 +90,12 @@
 	install -m 0644 README.txt README.html README_server.txt README_server.html docbook-xsl.css $(DESTDIR)$(docdir)/
 	install -d $(DESTDIR)$(man1dir)
 	install -m 0644 piuparts.1 $(DESTDIR)$(man1dir)/
+	gzip -9fn $(DESTDIR)$(man1dir)/piuparts.1
 	install -d $(DESTDIR)$(man8dir)
 	install -m 0644 piuparts_slave_run.8 piuparts_slave_join.8 piuparts_slave_stop.8 $(DESTDIR)$(man8dir)/
-	gzip -9f $(DESTDIR)$(man1dir)/piuparts.1
-	gzip -9f $(DESTDIR)$(man8dir)/piuparts_slave_run.8
-	gzip -9f $(DESTDIR)$(man8dir)/piuparts_slave_join.8
-	gzip -9f $(DESTDIR)$(man8dir)/piuparts_slave_stop.8
+	gzip -9fn $(DESTDIR)$(man8dir)/piuparts_slave_run.8
+	gzip -9fn $(DESTDIR)$(man8dir)/piuparts_slave_join.8
+	gzip -9fn $(DESTDIR)$(man8dir)/piuparts_slave_stop.8
 	install -m 0644 piuparts.1.html $(DESTDIR)$(docdir)/
 
 install-conf: build-stamp

=== instances/Makefile ===
ARCH				 = amd64
MIRROR				 = http://mirror.bm.debian.org/debian/

ARCH_piu-slave-1und1-01		 = i386
MIRROR_piu-slave-1und1-01	 = http://mirror.1und1.de/debian/
MIRROR_piu-slave-ubc-01		 = http://mirror-ubc.debian.org/debian/

GENCONF		 = piuparts.conf.pejacevic
GENCONF		+= piuparts.conf.piu-slave-bm-a
GENCONF		+= piuparts.conf.piu-slave-1und1-01
GENCONF		+= piuparts.conf.piu-slave-ubc-01

all: $(GENCONF)

clean:
	$(RM) $(GENCONF)

piuparts.conf.%: piuparts.conf-template.pejacevic Makefile piuparts.conf-header.%
	cat piuparts.conf-header.$* > $@.tmp
	echo "" >> $@.tmp
	sed 's,@MIRROR@,$(or $(MIRROR_$*),$(MIRROR)),; s,@ARCH@,$(or $(ARCH_$*),$(ARCH)),;' < $< >> $@.tmp
	mv $@.tmp $@

=== debian/changelog ===
piuparts (1.0.0+deb10u1) buster; urgency=medium

  * Happy 26th birthday, Debian! And many thanks to all the contributors!
 
  [ Andreas Beckmann ]
  * piuparts.py:
    - Add '--max-command-output-size' option to allow overriding the default
      of 8 MB for debugging runs.
    - Run pre_remove scripts before computing packages to be removed.
    - Fix spurious failure to remove packages with names ending with '+'.
  * piuparts-slave.py:
    - Generate separate tarball names for --merged-usr chroots.
  * detect_well_known_errors.py:
    - process untestable logs.
  * Makefile: use gzip -n for reproducibility.
  * piuparts.conf, distros.conf: Update for buster release.
  * custom-scripts: some updates for buster. If custom-scripts are used, it's
    probably better to use piuparts from bpo.

  [ Holger Levsen ]
  * Cherry-picking the above.

 -- Holger Levsen <holger@debian.org>  Fri, 16 Aug 2019 15:21:58 +0200

=== debian/control ===
--- 
+++ 
@@ -4,11 +4,11 @@
  Holger Levsen <holger@debian.org>
 Section: devel
 Priority: optional
-Standards-Version: 4.2.0
+Standards-Version: 4.3.0
 Rules-Requires-Root: no
 Build-Depends:
  asciidoc,
- debhelper (>= 11~),
+ debhelper-compat (= 11),
  dh-python,
  python (>= 2.7),
  python-debian,
@@ -24,7 +24,7 @@
 Build-Depends-Indep:
  git,
 Homepage: https://piuparts.debian.org
-Vcs-Git: https://salsa.debian.org/debian/piuparts
+Vcs-Git: https://salsa.debian.org/debian/piuparts.git
 Vcs-Browser: https://salsa.debian.org/debian/piuparts
 Xs-Go-Import-Path: salsa.debian.org/debian/piuparts
 
@@ -32,6 +32,7 @@
 Architecture: all
 Depends:
  piuparts-common (= ${binary:Version}),
+# keep this list in sync with piuparts-slave-from-git-deps
  debootstrap (>= 1.0.89~),
  debsums (>= 2.2.2~),
  lsb-release,
@@ -62,9 +63,11 @@
 Depends:
  piuparts-common (>= ${source:Version}),
  piuparts-common (<< ${source:Version}+),
+# keep this list in sync with piuparts-master-from-git-deps
  adduser,
  openssh-server,
  python-debianbts,
+ python-setproctitle,
  tango-icon-theme,
  xz-utils,
  python-yaml,
@@ -90,11 +93,42 @@
  operate. It also contains piuparts-report to generate web pages with the
  testing results as well as documentation.
 
+Package: piuparts-master-from-git-deps
+Architecture: all
+Depends:
+ git,
+# this list is synced from piuparts-master
+ adduser,
+ openssh-server,
+ python-debianbts,
+ python-setproctitle,
+ tango-icon-theme,
+ xz-utils,
+ python-yaml,
+ python (>= 2.7),
+# selected packages from piuparts-master Recommends
+ apache2 | httpd,
+ python-rpy2,
+# this list is synced from piuparts-common
+ python-apt,
+ python-distro-info,
+ python-lzma,
+ ${misc:Depends},
+Description: dependencies for running piuparts master from git
+ piuparts is meant as a quality assurance tool for people who create .deb
+ packages to test them before they upload them to the Debian package archive.
+ A master/slave piuparts installation is used for testing complete archives
+ as it is done on https://piuparts.debian.org/.
+ .
+ This metapackage provides all the dependencies needed for running a
+ piuparts-master instance (including piuparts-report etc.) from git.
+
 Package: piuparts-slave
 Architecture: all
 Depends:
  piuparts (= ${binary:Version}),
  piuparts-common (= ${binary:Version}),
+# keep this list in sync with piuparts-slave-from-git-deps
  adduser,
  openssh-client,
  screen,
@@ -113,9 +147,41 @@
  This package provides the piuparts slave components, which need a piuparts
  master to operate. See the documentation in the piuparts-master package.
 
+Package: piuparts-slave-from-git-deps
+Architecture: all
+Depends:
+ git,
+# this list is synced from piuparts-slave
+ adduser,
+ openssh-client,
+ screen,
+ sudo,
+ python (>= 2.7),
+# this list is synced from piuparts
+ debootstrap (>= 1.0.89~),
+ debsums (>= 2.2.2~),
+ lsb-release,
+ lsof,
+ mount,
+ python-debian,
+# this list is synced from piuparts-common
+ python-apt,
+ python-distro-info,
+ python-lzma,
+ ${misc:Depends},
+Description: dependencies for running piuparts slave from git
+ piuparts is meant as a quality assurance tool for people who create .deb
+ packages to test them before they upload them to the Debian package archive.
+ A master/slave piuparts installation is used for testing complete archives
+ as it is done on https://piuparts.debian.org/.
+ .
+ This metapackage provides all the dependencies needed for running a
+ piuparts-slave instance from git.
+
 Package: piuparts-common
 Architecture: all
 Depends:
+# keep this list in sync with piuparts-{master,slave}-from-git-deps
  python-apt,
  python-distro-info,
  python-lzma,
